The famous Korean internet company nhn has provided an internet-based photo service which allows The famous Korean internet company users to directly take a photo of an astronomical phenomenon in
space by controlling a high-performance telescope owned by nhn. A few days later, a meteoric shower, known as the biggest one in this century, is expected. nhn has announced a photo competition which awards the user who takes a photo containing as many meteors
as possible by using the photo service. For this competition, nhn provides the information on the trajectories of the meteors at their web page in advance. The best way to win is to compute the moment (the time) at which the telescope can catch the maximum
number of meteors.

You have n meteors, each moving in uniform linear motion; the meteor mi moves along the trajectory pi + t×vi over
time t , wheret is a non-negative real value, pi is the starting point of mi and vi is
the velocity of mi . The point pi = (xiyi) is represented by X -coordinate xi and Y -coordinate yi in
the (XY) -plane, and the velocity vi = (aibi) is a non-zero vector with two components ai and bi in
the (XY) -plane. For example, if pi = (1, 3) and vi = (-2, 5) , then the meteor mi will
be at the position (0, 5.5) at time t = 0.5 because pi + t×vi = (1, 3) + 0.5×(-2, 5) = (0, 5.5) . The telescope has a rectangular frame with the lower-left
corner (0, 0) and the upper-right corner (wh) . Refer to Figure 1. A meteor is said to be in the telescope frame if the meteor is in the interior of the frame (not on the boundary of the frame). For exam! ple,
in Figure 1, p2,p3p4 , and p5 cannot be taken by the telescope at any time because they do not pass the interior of the frame
at all. You need to compute a time at which the number of meteors in the frame of the telescope is maximized, and then output the maximum number of meteors.

Input

Your program is to read the input from standard input. The input consists of T test cases. The number of test cases T is given in the first line
of the input. Each test case starts with a line containing two integers w and h (1wh100,
000) , the width and height of the telescope frame, which are separated by single space. The second line contains an integer n , the number of input points (meteors), 1n100,
000 . Each of the next n lines contain four integers xiyiai , and bi ; (xiyi) is
the starting point pi and (aibi) is the nonzero velocity vector vi of the i -th
meteor; xi and yi are integer values between -200,000 and 200,000, and ai and bi are
integer values between -10 and 10. Note that at least one of ai and bi is not zero. These four values are separated by single spaces. We assume that all starting points pi are
distinct.

Output

Your program is to write to standard output. Print the maximum number of meteors which can be in the telescope frame at some moment.

2
4 2
2
-1 1 1 -1
5 2 -1 -1
13 6
7
3 -2 1 3
6 9 -2 -1
8 0 -1 -1
7 6 10 0
11 -2 2 1
-2 4 6 -1
3 2 -5 -1
1
2
 一.转化模型
  很容易就发现,流星通过镜框的时间是一段区间。
  那么问题可以等价于 找一个点,使他最多被多少个区间包含,输出区间数量最大值


 二.离散化+扫描线
  将点离散化存储,并且排序。当扫描线扫过左端点 now+1 右端点 now-1 其中出现的最大的now即为ans

 注意:
   如果时间相同的话 先右端点,后左端点。

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <string>
#define oo 2000000;
#define maxn 100001
using namespace std;
struct point
{
double x;
int flag;
};
point P[maxn*10]; int tot=0;
int w,h,n;
int x,y,a,b;
int getQuJian()
{
double t1,t2;
double t3,t4;
if(a!=0)
t1=((double)(-x)/a),t2=(double)(w-x)/a;
else
{
if (0<x&&x<w) { t1=0,t2=oo;}
else
{
t1=0;t2=0;
}
} if(b!=0)
t3=((double)(-y)/b),t4=(double)(h-y)/b;
else
{
if(0<y&&y<h){t3=0,t4=oo;}
else t3=0,t4=0;
}
if(a<0) swap(t1,t2);
if(b<0) swap(t3,t4);
if(t1>t2) return 0;
if(t3>t4) return 0;
if(t1<=t3)
{
if(t3<=t2)
{
if(t2<=t4)
{
if(t2!=t3)
{
if(t3<0&&t2>0) t3=0;
P[++tot].x=t3;P[tot].flag=0;
P[++tot].x=t2;P[tot].flag=1;
}
}
else
{
if(t3!=t4)
{
if(t3<0&&t4>0) t3=0;
P[++tot].x=t3;P[tot].flag=0;
P[++tot].x=t4;P[tot].flag=1;
}
}
}
else;
}
else
{
if(t1<=t4)
{
if(t4<=t2)
{
if(t1!=t4)
{
if(t1<0&&t4>0) t1=0;
P[++tot].x=t1;P[tot].flag=0;
P[++tot].x=t4;P[tot].flag=1;
}
}
else
{
if(t1!=t2)
{
if(t1<0&&t2>0) t1=0;
P[++tot].x=t1;P[tot].flag=0;
P[++tot].x=t2;P[tot].flag=1;
}
}
}
}
return 0;
}
int cmp(const void *i,const void *j)
{
point *ii=(point *)i,*jj=(point *)j;
if(ii->x!=jj->x)
if(ii->x>jj->x) return 1;
else return -1;
else return jj->flag-ii->flag;
}
int main()
{
freopen("a.in","r",stdin);
freopen("a.out","w",stdout);
int T,ans,now;
cin>>T;
while(T--)
{
tot=0,ans=0,now=0;
cin>>w>>h;
cin>>n;
for(int i=1;i<=n;i++)
{
cin>>x>>y>>a>>b;
getQuJian();
}
qsort(P+1,tot,sizeof(P[1]),cmp);
for(int i=1;i<=tot;i++)
{
if(P[i].x>0)
{
if(P[i].flag==1) now--;
else
{
now++;
ans=max(ans,now);
}
}
else if(P[i].x==0&&P[i].flag==0)
{
now++;
ans=max(ans,now);
}
}
cout<<ans<<endl;
}
return 0;
}

刘汝佳老师的求交集写的更优美(左端点与左端点比,右端点与右端点比,并且初始区间为【0,+oo】,使得没有我那么多麻烦的判断)


void update(int x, int a, int w, double& L, double& R) {
if(a == 0) {
if(x <= 0 || x >= w) R = L-1; //无解
} else if(a > 0) {
L = max(L, -(double)x/a);
R = min(R, (double)(w-x)/a);
} else {
L = max(L, (double)(w-x)/a);
R = min(R, -(double)x/a);
}
}

刘汝佳老师的整个题目解释:

【分析】

不难发现,流星的轨迹是没有直接意义的,有意义的只是每个流星在照相机视野内出现的时间段。换句话说,我们把本题抽象为这样一个问题:给出n个开区间(Li,Ri),你的任务是求出一个数t,使得包含它的区间数最多(为什么是开区间呢?请读者思考)。开区间(Li,Ri)是指所有满足Li<x
<Ri的实数x的集合。

把所有区间画到平行于数轴的直线上(免得相互遮挡,看不清楚),然后想象有一条竖直线从左到右进行扫描,则问题可以转化为:求扫描线在哪个位置时与最多的开区间相交,如图1-27所示。

图  1-27

不难发现,当扫描线移动到某个区间左端点的“右边一点点”时最有希望和最多的开区间相交(想一想,为什么)。为了快速得知在这些位置时扫描线与多少条线段相交,我们再一次使用前面提到的技巧:维护信息,而不是重新计算。

我们把“扫描线碰到一个左端点”和“扫描线碰到一个右端点”看成是事件(event),则扫描线移动的过程就是从左到右处理各个事件的过程。每遇到一个“左端点事件”,计数器加1;每遇到一个“右端点事件”,计数器减1。这里的计数器保存的正是我们要维护的信息:扫描线和多少个开区间相交,如图1-28所示。

图  1-28

这样,我们可以写出这样一段伪代码。

将所有事件按照从左到右排序

while(还有未处理的事件) {

选择最左边的事件E

if(E是“左端点事件”) { cnt++; if(cnt > ans) ans= cnt; } //更新计数器和答案

else cnt--;//一定是“右端点事件”

}

这段伪代码看上去挺有道理,但实际上暗藏危险:如果不同事件的端点相同,那么哪个排在前面呢?考虑这样一种情况——输入是两个没有公共元素的开区间,且左边那个区间的右端点和右边那个区间的左端点重合。在这种情况下,两种排法的结果截然不同:如果先处理左端点事件,执行结果是2;如果先处理右端点事件,执行结果是1。这才是正确答案。

这样,我们得到了一个完整的扫描算法:先按照从左到右的顺序给事件排序,对于位置相同的事件,把右端点事件排在前面,然后执行上述伪代码的循环部分。如果你对这个冲突解决方法心存疑虑,不妨把它理解成把所有区间的右端点往左移动了一个极小(但大于0)的距离。


#include<cstdio>
#include<algorithm>
using namespace std;
//0<x+at<w
void update(int x, int a, int w, double& L, double& R) {
if(a == 0) {
if(x <= 0 || x >= w) R = L-1; //无解
} else if(a > 0) {
L = max(L, -(double)x/a);
R = min(R, (double)(w-x)/a);
} else {
L = max(L, (double)(w-x)/a);
R = min(R, -(double)x/a);
}
} const int maxn = 100000 + 10; struct Event {
double x;
int type;
bool operator < (const Event& a) const {
return x < a.x || (x == a.x && type > a.type); //先处理右端点
}
} events[maxn*2]; int main() {
int T;
scanf("%d", &T);
while(T--) {
int w, h, n, e = 0;
scanf("%d%d%d", &w, &h, &n);
for(int i = 0; i < n; i++) {
int x, y, a, b;
scanf("%d%d%d%d", &x, &y, &a, &b);
//0<x+at<w, 0<y+bt<h, t>=0
double L = 0, R = 1e9;
update(x, a, w, L, R);
update(y, b, h, L, R);
if(R > L) {
events[e++] = (Event){L, 0};
events[e++] = (Event){R, 1};
}
}
sort(events, events+e);
int cnt = 0, ans = 0;
for(int i = 0; i < e; i++) {
if(events[i].type == 0) ans = max(ans, ++cnt);
else cnt--;
}
printf("%d\n", ans);
}
return 0;
}

另外,本题还可以完全避免实数运算,全部采用整数:只需要把代码中的double全部改成int,然后在update函数中把所有返回值乘以lcm(1,2,…,10)=2 520即可(想一想,为什么)。

因为2520 是他们的公倍数 除出来必定是整数

void update(int x, int a, int w, int& L,int& R) {
if(a == 0){
if(x<= 0 || x >= w) R = L-1; //无解
} else if(a> 0) {
L =max(L, -x*2520/a);
R =min(R, (w-x)*2520/a);
} else {
L =max(L, (w-x)*2520/a);
R =min(R, -x*2520/a);
}
}

【转换模型+扫描线】【UVA1398】Meteor的更多相关文章

  1. 性能测试学习之三—— PV->TPS转换模型&TPS波动模型

    PV->TPS转换模型 由上一篇“性能测试学习之二 ——性能测试模型(PV计算模型)“ 得知 TPS = ( (80%*总PV)/(24*60*60*(T/24)))/服务器数量 转换需要注意: ...

  2. [源码解析] 深度学习流水线并行 PipeDream(3)--- 转换模型

    [源码解析] 深度学习流水线并行 PipeDream(3)--- 转换模型 目录 [源码解析] 深度学习流水线并行 PipeDream(3)--- 转换模型 0x00 摘要 0x01 前言 1.1 改 ...

  3. Uva1398 Meteor

    扫描线法. 将流星出现在相机里的时间转化成线段,离散化端点后,扫描何时出现的流星最多.注意边界的不算,所以要先减右端点再加左端点 /*By SilverN*/ #include<iostream ...

  4. 使用Blender批量导出/转换模型

    2.4版本号的Blender API和2.5以上版本号的API有非常大的不同,这里仅仅是提供了思路和2.4版本号的导出方案. 先提供一个脚本,这个是由Blender调用的.用于转换Ogre的Mesh文 ...

  5. 全参考视频质量评价方法(PSNR,SSIM)以及与MOS转换模型

    转载处:http://blog.csdn.NET/leixiaohua1020/article/details/11694369 最常用的全参考视频质量评价方法有以下2种: PSNR(峰值信噪比):用 ...

  6. 动态规划(模型转换):uvaoj 1625 Color Length

    [PDF Link]题目点这里 这道题一眼就是动态规划,然而貌似并不好做. 如果不转换模型,状态是难以处理的. 巧妙地转化:不直接求一种字母头尾距离,而是拆开放到状态中. #include <i ...

  7. [转]kaldi特征和模型空间转换

    转:http://blog.csdn.net/shmilyforyq/article/details/76807431 博主话:这篇博客是对kaldi官网中Feature and model-spac ...

  8. 3D模型预处理(格式转换:obj转换为gltf)

    在cesium中导入模型需要的是gltf或glb格式的文件,cesium官方提供了obj转gltf文件的工具,一个obj2gltf的库,地址为https://github.com/Analytical ...

  9. Pytorch | BERT模型实现,提供转换脚本【横扫NLP】

    <谷歌终于开源BERT代码:3 亿参数量,机器之心全面解读>,上周推送的这篇文章,全面解读基于TensorFlow实现的BERT代码.现在,PyTorch用户的福利来了:一个名为Huggi ...

随机推荐

  1. Codeforces 474C Captain Marmot 给定4个点和各自旋转中心 问旋转成正方形的次数

    题目链接:点击打开链接 题意: 给定T表示case数 以下4行是一个case 每行2个点,u v 每次u能够绕着v逆时针转90° 问最少操作多少次使得4个u构成一个正方形. 思路: 枚举判可行 #in ...

  2. iOS 中的正则匹配(工具类方法)

    正则表达式 正则表达式是对字符串操作的一种逻辑公式, 用事先定义好的一些特定字符.及这些特定字符的组合, 组成一个"规则字符串", 这个"规则字符串"用来表达对 ...

  3. UIImageView 一些属性设置

    1.contentMode属性 这个属性是用来设置图片的显示方式,如居中.居右,是否缩放等,有以下几个常量可供设定: UIViewContentModeScaleToFill UIViewConten ...

  4. im2uint8函数分析

    环境:Win7 64位 + Matlab R2010a 本次分析的函数为im2uint8,这个函数在图像处理中要用到,主要把图像数据类转换到uint8 uint8函数有效的输入的图像数据类为:logi ...

  5. Java的反射机制及应用实例

    一:什么是反射机制 简单的来说,反射机制指的是程序在运行时能够获取自身的信息.在Java中,只要给定类的名字,那么就可以通过反射机制来获得类的所有信息. 二:哪里用到反射机制 我们用过一些知识,但是并 ...

  6. Hibernate中HQL的日期差值计算,可计算相差多少秒

    最近有个业务需求就是计算订单创建时间离现在超过 4 小时的订单都查找出来! 那么就需要用到日期函数了. 网上找了一下总共的日期函数有一下几个: CURRENT_DATE() 返回数据库当前日期 时间函 ...

  7. [Head First Python]3. 文件与异常:处理错误

    datafile.txt Man: Is this the right room for an argument? Other Man: I've told you once. Man: No you ...

  8. 前端上将字符串用语音读出来只能在IE上运行 其他不行 代码极少

    先保存保存自己的笔记 有高手看到求指点 <script type="text/javascript"> var VoiceObj; try { VoiceObj = n ...

  9. mysql-test库要命的地方

    为了见识test库对整个mysql实例安全的影响,我将建立一个appuser@'%' 用户,它只有一个权限那就是可以连接上mysql. 001. 以高权限用户登录mysql.创建一个appuser@' ...

  10. request.getParamer()

    eturns the value of a request parameter as a String, or null if the parameter does not exist. Reques ...